# This script is created by NSG2 beta1
# <http://wushoupong.googlepages.com/nsg>

#===================================
#        Initialization        
#===================================
#Create a ns simulator
set ns [new Simulator -multicast on]
#ns-random 0 

 
#Open the NS trace file
set tracefile [open out.tr w]
$ns trace-all $tracefile

#Open the NAM trace file
set namfile [open out.nam w]
$ns namtrace-all $namfile

set f0 [open sink0.tr w]
set f2 [open sink2.tr w]
set f4 [open sink4.tr w]
set f8 [open sink8.tr w]
set r1 [open  s1.tr w]
set r3 [open  s3.tr w]
set r5 [open  s5.tr w]
set r6 [open  s6.tr w]


#===================================
#     Simulation parameters setup
#===================================
set opt(stop)   500.0
set opt(low)	100kb
set opt(medium)	300kb
set opt(high)   600kb
set opt(report_interval) 500ms

$ns color 1 red
$ns color 30 purple
$ns color 31 bisque
$ns color 32 green


#===================================
#        Nodes Definition        
#===================================
#Create 27 nodes

for {set i 0} {$i < 30} {incr i} {
	set n$i [$ns node]
}

$n1 shape "box"
$n2 shape "box"
$n3 shape "box"
$n4 shape "box"
$n5 shape "box"
$n0 label "Multicast-Server"
$n15 label "Multicast-Receiver"
$n16 label "Multicast-Receiver"
$n17 label "Multicast-Receiver"


#===================================
#        Links Definition        
#===================================
#Createlinks between nodes
$ns duplex-link $n1 $n2 200.0Mb 50ms RED
$ns queue-limit $n1 $n2 50
$ns duplex-link $n2 $n3 0.8Mb 10ms RED
$ns queue-limit $n2 $n3 50
$ns duplex-link $n2 $n4 1.5.0Mb 10ms RED
$ns queue-limit $n2 $n4 50
$ns duplex-link $n2 $n5 3.0Mb 10ms RED
$ns queue-limit $n2 $n5 50

$ns duplex-link $n0 $n1 10Mb 5ms RED
$ns queue-limit $n0 $n1 50
$ns duplex-link $n6 $n1 10Mb 5ms RED
$ns queue-limit $n6 $n1 50
$ns duplex-link $n7 $n1 10Mb 5ms RED
$ns queue-limit $n7 $n1 50
$ns duplex-link $n8 $n1 10Mb 5ms RED
$ns queue-limit $n8 $n1 50
$ns duplex-link $n9 $n1 10Mb 5ms RED
$ns queue-limit $n9 $n1 50
$ns duplex-link $n10 $n1 10Mb 5ms RED
$ns queue-limit $n10 $n1 50
$ns duplex-link $n11 $n1 10Mb 5ms RED
$ns queue-limit $n11 $n1 50
$ns duplex-link $n12 $n1 10Mb 5ms RED
$ns queue-limit $n12 $n1 50
$ns duplex-link $n13 $n1 10Mb 5ms RED
$ns queue-limit $n13 $n1 50
$ns duplex-link $n14 $n1 10Mb 5ms RED
$ns queue-limit $n14 $n1 50

$ns duplex-link $n3 $n15 100Mb 5ms RED
$ns queue-limit $n3 $n15 50
$ns duplex-link $n3 $n18 100Mb 5ms RED
$ns queue-limit $n3 $n18 50
$ns duplex-link $n3 $n19 100Mb 5ms RED
$ns queue-limit $n3 $n19 50
$ns duplex-link $n3 $n27 100Mb 5ms RED
$ns queue-limit $n3 $n27 50

$ns duplex-link $n4 $n16 100Mb 5ms RED
$ns queue-limit $n4 $n16 50
$ns duplex-link $n4 $n20 100Mb 5ms RED
$ns queue-limit $n4 $n20 50
$ns duplex-link $n4 $n21 100Mb 5ms RED
$ns queue-limit $n4 $n21 50
$ns duplex-link $n4 $n28 100Mb 5ms RED
$ns queue-limit $n4 $n28 50

$ns duplex-link $n5 $n17 100Mb 5ms RED
$ns queue-limit $n5 $n17 50
$ns duplex-link $n5 $n22  100Mb 5ms RED
$ns queue-limit $n5 $n22 50
$ns duplex-link $n5 $n23 100Mb 5ms RED
$ns queue-limit $n5 $n23 50
$ns duplex-link $n5 $n24 100Mb 5ms RED
$ns queue-limit $n5 $n24 50
$ns duplex-link $n5 $n25 100Mb 5ms RED
$ns queue-limit $n5 $n25 50
$ns duplex-link $n5 $n26 100Mb 5ms RED
$ns queue-limit $n5 $n26 50
$ns duplex-link $n5 $n29 100Mb 5ms RED
$ns queue-limit $n5 $n29 50




#===================================
#        Agents Definition        
#===================================
 #Setup a TCP connection
set tcp0 [new Agent/TCP]
$ns attach-agent $n6 $tcp0
set sink0 [new Agent/TCPSink]
$ns attach-agent $n18 $sink0
$ns connect $tcp0 $sink0
$tcp0 set packetSize_ 1000

#Setup a TCP connection
set tcp1 [new Agent/TCP]
$ns attach-agent $n7 $tcp1
set sink1 [new Agent/TCPSink]
$ns attach-agent $n19 $sink1
$ns connect $tcp1 $sink1
$tcp1 set packetSize_ 1000

#Setup a TCP connection
set tcp2 [new Agent/TCP]
$ns attach-agent $n8 $tcp2
set sink2 [new Agent/TCPSink]
$ns attach-agent $n20 $sink2
$ns connect $tcp2 $sink2
$tcp2 set packetSize_ 1000

#Setup a TCP connection
set tcp3 [new Agent/TCP]
$ns attach-agent $n9 $tcp3
set sink3 [new Agent/TCPSink]
$ns attach-agent $n21 $sink3
$ns connect $tcp3 $sink3
$tcp2 set packetSize_ 1000

#Setup a TCP connection
set tcp4 [new Agent/TCP]
$ns attach-agent $n10 $tcp4
set sink4 [new Agent/TCPSink]
$ns attach-agent $n22 $sink4
$ns connect $tcp4 $sink4
$tcp2 set packetSize_ 1000

#Setup a TCP connection
set tcp5 [new Agent/TCP]
$ns attach-agent $n11 $tcp5
set sink5 [new Agent/TCPSink]
$ns attach-agent $n23 $sink5
$ns connect $tcp5 $sink5
$tcp2 set packetSize_ 1000

#Setup a TCP connection
set tcp6 [new Agent/TCP]
$ns attach-agent $n12 $tcp6
set sink6 [new Agent/TCPSink]
$ns attach-agent $n24 $sink6
$ns connect $tcp6 $sink6
$tcp2 set packetSize_ 1000

#Setup a TCP connection
set tcp7 [new Agent/TCP]
$ns attach-agent $n13 $tcp7
set sink7 [new Agent/TCPSink]
$ns attach-agent $n25 $sink7
$ns connect $tcp7 $sink7
$tcp2 set packetSize_ 1000

#Setup a TCP connection
set tcp8 [new Agent/TCP]
$ns attach-agent $n14 $tcp8
set sink8 [new Agent/TCPSink]
$ns attach-agent $n26 $sink8
$ns connect $tcp8 $sink8
$tcp2 set packetSize_ 1000


#===================================
#        Applications Definition        
#===================================
#Setup a FTP Application over TCP/Reno connection
set ftp0 [new Application/FTP]
$ftp0 attach-agent $tcp0
$ftp0 set rate_ 100kb
#$ftp0 set random_ 1
$ns at 1.0 "$ftp0 start"
$ns at $opt(stop)  "$ftp0 stop"

#Setup a FTP Application over TCP/Reno connection
set ftp1 [new Application/FTP]
$ftp1 attach-agent $tcp1
$ftp1 set rate_ 100kb
$ns at 1.0 "$ftp1 start"
$ns at $opt(stop)  "$ftp1 stop"

#Setup a FTP Application over TCP/Reno connection
set ftp2 [new Application/FTP]
$ftp2 attach-agent $tcp2
$ftp2 set rate_ 100kb
$ns at 1.0 "$ftp2 start"
$ns at $opt(stop)  "$ftp2 stop"

#Setup a FTP Application over TCP/Reno connection
set ftp3 [new Application/FTP]
$ftp3 attach-agent $tcp3
$ftp3 set rate_ 100kb
$ns at 1.0 "$ftp3 start"
$ns at $opt(stop)  "$ftp3 stop"

#Setup a FTP Application over TCP/Reno connection
set ftp4 [new Application/FTP]
$ftp4 attach-agent $tcp4
$ftp4 set rate_ 100kb
$ns at 1.0 "$ftp4 start"
$ns at $opt(stop)  "$ftp4 stop"

#Setup a FTP Application over TCP/Reno connection
set ftp5 [new Application/FTP]
$ftp5 attach-agent $tcp5
$ftp5 set rate_ 100kb
$ns at 1.0 "$ftp5 start"
$ns at $opt(stop)  "$ftp5 stop"

#Setup a FTP Application over TCP/Reno connection
set ftp6 [new Application/FTP]
$ftp6 attach-agent $tcp6
$ftp6 set rate_ 100kb
$ns at 100.0 "$ftp6 start"
$ns at 125.0  "$ftp6 stop"
$ns at 300.0 "$ftp6 start"
$ns at 325.0  "$ftp6 stop"


#Setup a FTP Application over TCP/Reno connection
set ftp7 [new Application/FTP]
$ftp7 attach-agent $tcp7
$ftp7 set rate_ 100kb
$ns at 100.0 "$ftp7 start"
$ns at 125.0  "$ftp7 stop"
$ns at 300.0 "$ftp7 start"
$ns at 325.0  "$ftp7 stop"


#Setup a FTP Application over TCP/Reno connection
set ftp8 [new Application/FTP]
$ftp8 attach-agent $tcp8
$ftp8 set rate_ 100kb
$ns at 100.0 "$ftp8 start"
$ns at 125.0  "$ftp8 stop"
$ns at 300.0 "$ftp8 start"
$ns at 325.0  "$ftp8 stop"



#===================================
#        Smooth multicast congestion
#	 control over RTP
#===================================
# configure multicast protocol;
#set mproto CtrMcast
set mproto DM
# all nodes will contain multicast protocol agents;
set mrthandle [$ns mrtproto $mproto]
# allocate a multicast address;
set group1 [Node allocaddr]
set group2 [Node allocaddr]
set group3 [Node allocaddr]


set s0 [new SimStream/RTP ]
$s0 set isSender true
#$s0 report-interval $opt(report_interval)
$s0 session_bw-low    $opt(low)
$s0 session_bw-medium    $opt(medium)
$s0 session_bw-high    $opt(high)
$s0 initial-rate-low  $opt(low)
$s0 initial-rate-medium  $opt(medium)
$s0 initial-rate-high  $opt(high)

$s0 low-stream-limits 		100kb 300kb
$s0 medium-stream-limits 	300kb 500kb
$s0 high-stream-limits 		500kb 1.5Mb


$s0 attach-node $n0
# enable congestion control
$s0 enable-control 1

set s1 [new SimStream/RTP ]
$s1 set isReceiver true
$s1 set level_ 1
$s1 session_bw-low    $opt(low)
$s1 session_bw-medium    $opt(medium)
$s1 session_bw-high    $opt(high)
$s1 initial-rate-low   $opt(low)
$s1 initial-rate-medium   $opt(medium)
$s1 initial-rate-high  $opt(high)
$s1 streams-threshold $opt(low) $opt(medium) $opt(high)
$s1 attach-node $n15

set s2 [new SimStream/RTP ]
$s2 set isReceiver true
$s2 set level_ 1
$s2 session_bw-low    $opt(low)
$s2 session_bw-medium    $opt(medium)
$s2 session_bw-high    $opt(high)
$s2 initial-rate-low   $opt(low)
$s2 initial-rate-medium   $opt(medium)
$s2 initial-rate-high  $opt(high)
$s2 streams-threshold $opt(low) $opt(medium) $opt(high)
$s2 attach-node $n27

set s3 [new SimStream/RTP ]
$s3 set isReceiver true
$s3 set level_ 2
$s3 session_bw-low    $opt(low)
$s3 session_bw-medium    $opt(medium)
$s3 session_bw-high    $opt(high)
$s3 initial-rate-low   $opt(low)
$s3 initial-rate-medium   $opt(medium)
$s3 initial-rate-high  $opt(high)
$s3 streams-threshold $opt(low) $opt(medium) $opt(high)
$s3 attach-node $n16

set s4 [new SimStream/RTP ]
$s4 set isReceiver true
$s4 set level_ 2
$s4 session_bw-low    $opt(low)
$s4 session_bw-medium    $opt(medium)
$s4 session_bw-high    $opt(high)
$s4 initial-rate-low   $opt(low)
$s4 initial-rate-medium   $opt(medium)
$s4 initial-rate-high  $opt(high)
$s4 streams-threshold $opt(low) $opt(medium) $opt(high)
$s4 attach-node $n28

set s5 [new SimStream/RTP ]
$s5 set isReceiver true
$s5 set level_ 3
$s5 session_bw-low    $opt(low)
$s5 session_bw-medium    $opt(medium)
$s5 session_bw-high    $opt(high)
$s5 initial-rate-low   $opt(low)
$s5 initial-rate-medium   $opt(medium)
$s5 initial-rate-high  $opt(high)
$s5 streams-threshold $opt(low) $opt(medium) $opt(high)
$s5 attach-node $n17

set s6 [new SimStream/RTP ]
$s6 set isReceiver true
$s6 set level_ 3
$s6 session_bw-low    $opt(low)
$s6 session_bw-medium    $opt(medium)
$s6 session_bw-high    $opt(high)
$s6 initial-rate-low   $opt(low)
$s6 initial-rate-medium   $opt(medium)
$s6 initial-rate-high  $opt(high)
$s6 streams-threshold $opt(low) $opt(medium) $opt(high)
$s6 attach-node $n29


$ns at 0.1 "$s0 join-groups $group1 $group2 $group3"
$ns at 0.1 "$s0 start"

$ns at 0.2 "$s1 assign-groups $group1 $group2 $group3"
$ns at 0.2 "$s1 join-group $group1"
$ns at 0.2 "$s1 start-session $group1"

$ns at 0.3 "$s2 assign-groups $group1 $group2 $group3"
$ns at 0.3 "$s2 join-group $group1"
$ns at 0.3 "$s2 start-session $group1"

$ns at 0.4 "$s3 assign-groups $group1 $group2 $group3"
$ns at 0.4 "$s3 join-group $group2"
$ns at 0.4 "$s3 start-session $group2"

$ns at 0.4 "$s4 assign-groups $group1 $group2 $group3"
$ns at 0.4 "$s4 join-group $group2"
$ns at 0.4 "$s4 start-session $group2"

$ns at 0.4 "$s5 assign-groups $group1 $group2 $group3"
$ns at 0.4 "$s5 join-group $group3"
$ns at 0.4 "$s5 start-session $group3"

$ns at 0.4 "$s6 assign-groups $group1 $group2 $group3"
$ns at 0.4 "$s6 join-group $group3"
$ns at 0.4 "$s6 start-session $group3"

$ns at 1.0 "$s0 transmit-low		$opt(low)"
$ns at 1.0 "$s0 transmit-medium		$opt(medium)"
$ns at 1.0 "$s0 transmit-high		$opt(high)"




#===================================
#        Record functions
#===================================
$ns at 1.0 "record-sink0"
$ns at 1.0 "record-sink2"
$ns at 1.0 "record-sink4"
$ns at 1.0 "record-sink8"
$ns at 1.0 "record-s1"
$ns at 1.0 "record-s3"
$ns at 1.0 "record-s5"
$ns at 1.0 "record-s6"

# record the TCP throughput
proc record-sink0 {} {
        global sink0 f0
	#Get an instance of the simulator
	set ns [Simulator instance]
	#Set the time after which the procedure should be called again
        set time 0.5
	#How many bytes have been received by the traffic?
	set bw0 [$sink0 set bytes_]
        #Get the current time
        set now [$ns now]
	puts "$now"
#	puts "$now"
	#Calculate the bandwidth (in MBit/s) and write it to the files
	puts $f0 "$now [expr $bw0/$time*8]"
        #Reset the bytes_ values on the traffic sinks
        $sink0 set bytes_ 0
       	#Re-schedule the procedure
        $ns at [expr $now+$time] "record-sink0"
}
# record the TCP throughput
proc record-sink2 {} {
        global sink2 f2
	#Get an instance of the simulator
	set ns [Simulator instance]
	#Set the time after which the procedure should be called again
        set time 0.5
	#How many bytes have been received by the traffic?
	set bw0 [$sink2 set bytes_]
        #Get the current time
        set now [$ns now]
	#Calculate the bandwidth (in MBit/s) and write it to the files
	puts $f2 "$now [expr $bw0/$time*8]"
        #Reset the bytes_ values on the traffic sinks
        $sink2 set bytes_ 0
       	#Re-schedule the procedure
        $ns at [expr $now+$time] "record-sink2"
}

# record the TCP throughput
proc record-sink4 {} {
        global sink4 f4
	#Get an instance of the simulator
	set ns [Simulator instance]
	#Set the time after which the procedure should be called again
        set time 0.5
	#How many bytes have been received by the traffic?
	set bw0 [$sink4 set bytes_]
        #Get the current time
        set now [$ns now]
	#Calculate the bandwidth (in MBit/s) and write it to the files
	puts $f4 "$now [expr $bw0/$time*8]"
        #Reset the bytes_ values on the traffic sinks
        $sink4 set bytes_ 0
       	#Re-schedule the procedure
        $ns at [expr $now+$time] "record-sink4"
}

# record the TCP throughput
proc record-sink8 {} {
        global sink8 f8
	#Get an instance of the simulator
	set ns [Simulator instance]
	#Set the time after which the procedure should be called again
        set time 0.5
	#How many bytes have been received by the traffic?
	set bw0 [$sink8 set bytes_]
        #Get the current time
        set now [$ns now]
	#Calculate the bandwidth (in MBit/s) and write it to the files
	puts $f8 "$now [expr $bw0/$time*8]"
        #Reset the bytes_ values on the traffic sinks
        $sink8 set bytes_ 0
       	#Re-schedule the procedure
        $ns at [expr $now+$time] "record-sink8"
}

# record s1 thrughput
proc record-s1 {} {
	global s1 r1
        set ns [Simulator instance]
        set time  0.5
	set bw  [$s1 set rcv_rate_]
	set now [$ns now]
	puts $r1 "$now $bw"
        $ns at [expr $now+$time] "record-s1"
}

# record s2 thrughput
proc record-s3 {} {
        global s3 r3
        set ns [Simulator instance]
        set time  0.5
	set bw  [$s3 set rcv_rate_]
	set now [$ns now]
        puts $r3 "$now $bw"
        $ns at [expr $now+$time] "record-s3"
}

# record s2 thrughput
proc record-s5 {} {
        global s5 r5
        set ns [Simulator instance]
        set time  0.5
	set bw  [$s5 set rcv_rate_]
	set now [$ns now]
        puts $r5 "$now $bw"
        $ns at [expr $now+$time] "record-s5"
}

# record s2 thrughput
proc record-s6 {} {
        global s6 r6
        set ns [Simulator instance]
        set time  0.5
	set bw  [$s6 set rcv_rate_]
	set now [$ns now]
        puts $r6 "$now $bw"
        $ns at [expr $now+$time] "record-s6"
}

#===================================
#        Termination        
#===================================
#Define a 'finish' procedure
proc finish {} {
     global ns f0 f2 f4 f8 r1  r3 r5 r6 namfile tracefile
     close $f0
     close $f2
     close $f4
     close $f8
     close $r1
     close $r3
     close $r5
     close $r6
    
     exec xgraph   sink0.tr sink2.tr  sink4.tr sink8.tr s1.tr s3.tr s5.tr s6.tr  -geometry 800x400  &

    $ns flush-trace
    close $tracefile
    close $namfile
    exec nam out.nam &
    exit 0
}



$ns at $opt(stop) "finish"
$ns run
