# This script is created by NSG2 beta1
# <http://wushoupong.googlepages.com/nsg>

#===================================
#        Initialization        
#===================================
#Create a ns simulator
set ns [new Simulator -multicast on]

#Open the NS trace file
set tracefile [open out.tr w]
$ns trace-all $tracefile

#Open the NAM trace file
set namfile [open out.nam w]
$ns namtrace-all $namfile

set f3 [open sink3.tr w]
set f4 [open sink4.tr w]
set f5 [open sink5.tr w]
set r1 [open  s1.tr w]
set r2 [open  s2.tr w]
set r3 [open  s3.tr w]
set r4 [open  s4.tr w]
set r5 [open  s5.tr w]
set r6 [open  s6.tr w]


#===================================
#     Simulation parameters setup
#===================================
set opt(stop)   100.0
set opt(low)	50kb
set opt(medium)	100kb
set opt(high)   200kb
set opt(report_interval) 500ms

$ns color 1 red
$ns color 30 purple
$ns color 31 bisque
$ns color 32 green


#===================================
#        Nodes Definition        
#===================================
#Create 17 nodes
set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]
set n4 [$ns node]
set n5 [$ns node]
set n6 [$ns node]
set n7 [$ns node]
set n8 [$ns node]
set n9 [$ns node]
set n10 [$ns node]
set n11 [$ns node]
set n12 [$ns node]
set n13 [$ns node]
set n14 [$ns node]
set n15 [$ns node]
set n16 [$ns node]

$n0 shape "box"
$n1 shape "box"
$n2 shape "box"
$n3 shape "box"
$n4 label "Multicast-Server"
$n5 label "TCP"
$n6 label "TCP"
$n7 label "TCP"
$n10 label "TCPSink"
$n13 label "TCPSink"
$n16 label "TCPSink"
$n0 label "IP-Router 1"
$n1 label "IP-Router 1"
$n2 label "IP-Router 2"
$n3 label "IP-Router 3"
$n8 label "Multicast-Receiver"
$n9 label "Multicast-Receiver"
$n11 label "Multicast-Receiver"
$n12 label "Multicast-Receiver"
$n14 label "Multicast-Receiver"
$n15 label "Multicast-Receiver"


#===================================
#        Links Definition        
#===================================
#Createlinks between nodes
$ns duplex-link $n4 $n0 10.0Mb 10ms RED
$ns queue-limit $n4 $n0 50
$ns duplex-link $n0 $n5 10.0Mb 10ms RED
$ns queue-limit $n0 $n5 50
$ns duplex-link $n0 $n6 10.0Mb 10ms RED
$ns queue-limit $n0 $n6 50
$ns duplex-link $n0 $n7 10.0Mb 10ms RED
$ns queue-limit $n0 $n7 50
$ns duplex-link $n2 $n0 0.8Mb 10ms RED
$ns queue-limit $n2 $n0 50
$ns duplex-link $n1 $n0 1.8Mb 10ms RED
$ns queue-limit $n1 $n0 50
$ns duplex-link $n0 $n3 2.5Mb 10ms RED
$ns queue-limit $n0 $n3 50
$ns duplex-link $n8 $n2 1.0Mb 10ms RED
$ns queue-limit $n8 $n2 50
$ns duplex-link $n9 $n2 1.0Mb 10ms RED
$ns queue-limit $n9 $n2 50
$ns duplex-link $n10 $n2 1.0Mb 10ms RED
$ns queue-limit $n10 $n2 50
$ns duplex-link $n11 $n1 2.5Mb 10ms RED
$ns queue-limit $n11 $n1 50
$ns duplex-link $n12 $n1 2.5Mb 10ms RED
$ns queue-limit $n12 $n1 50
$ns duplex-link $n13 $n1 2.5Mb 10ms RED
$ns queue-limit $n13 $n1 50
$ns duplex-link $n3 $n14 3.5Mb 10ms RED
$ns queue-limit $n3 $n14 50
$ns duplex-link $n3 $n15 3.5Mb 10ms RED
$ns queue-limit $n3 $n15 50
$ns duplex-link $n3 $n16 3.5Mb 10ms RED
$ns queue-limit $n3 $n16 50

#===================================
#        Agents Definition        
#===================================
 #Setup a TCP connection
set tcp0 [new Agent/TCP]
$ns attach-agent $n5 $tcp0
set sink3 [new Agent/TCPSink]
$ns attach-agent $n10 $sink3
$ns connect $tcp0 $sink3
$tcp0 set packetSize_ 1000

#Setup a TCP connection
set tcp1 [new Agent/TCP]
$ns attach-agent $n6 $tcp1
set sink4 [new Agent/TCPSink]
$ns attach-agent $n13 $sink4
$ns connect $tcp1 $sink4
$tcp1 set packetSize_ 1000

#Setup a TCP connection
set tcp2 [new Agent/TCP]
$ns attach-agent $n7 $tcp2
set sink5 [new Agent/TCPSink]
$ns attach-agent $n16 $sink5
$ns connect $tcp2 $sink5
$tcp2 set packetSize_ 1000

#===================================
#        Applications Definition        
#===================================
#Setup a FTP Application over TCP/Reno connection
set ftp0 [new Application/FTP]
$ftp0 attach-agent $tcp0
$ns at 1.0 "$ftp0 start"
$ns at $opt(stop)  "$ftp0 stop"

#Setup a FTP Application over TCP/Reno connection
set ftp1 [new Application/FTP]
$ftp1 attach-agent $tcp1
$ns at 1.0 "$ftp1 start"
$ns at $opt(stop)  "$ftp1 stop"

#Setup a FTP Application over TCP/Reno connection
set ftp2 [new Application/FTP]
$ftp2 attach-agent $tcp2
$ns at 1.0 "$ftp2 start"
$ns at $opt(stop)  "$ftp2 stop"

#===================================
#        Smooth multicast congestion
#	 control over RTP
#===================================
# configure multicast protocol;
#set mproto CtrMcast
set mproto DM
# all nodes will contain multicast protocol agents;
set mrthandle [$ns mrtproto $mproto]
# allocate a multicast address;
set group1 [Node allocaddr]
set group2 [Node allocaddr]
set group3 [Node allocaddr]


set s0 [new SimStream/RTP ]
$s0 set isSender true
#$s0 report-interval $opt(report_interval)
$s0 session_bw-low    $opt(low)
$s0 session_bw-medium    $opt(medium)
$s0 session_bw-high    $opt(high)
$s0 initial-rate-low  10kb
$s0 initial-rate-medium  30kb
$s0 initial-rate-high  50kb

$s0 low-stream-limits 		100kb 600kb
$s0 medium-stream-limits 	500kb 1100kb
$s0 high-stream-limits 		800kb 1.6Mb


$s0 attach-node $n4
# enable congestion control
$s0 enable-control 1

set s1 [new SimStream/RTP ]
$s1 set isReceiver true
$s1 set level_ 1
#$s0 report-interval $opt(report_interval)
$s1 session_bw-low    $opt(low)
$s1 session_bw-medium    $opt(medium)
$s1 session_bw-high    $opt(high)
$s1 initial-rate-low  10kb
$s1 initial-rate-medium  30kb
$s1 initial-rate-high  50kb
$s1 streams-threshold 100kb 500kb 800kb
$s1 attach-node $n8

set s2 [new SimStream/RTP ]
$s2 set isReceiver true
$s2 set level_ 1
#$s0 report-interval $opt(report_interval)
$s2 session_bw-low    $opt(low)
$s2 session_bw-medium    $opt(medium)
$s2 session_bw-high    $opt(high)
$s2 initial-rate-low  10kb
$s2 initial-rate-medium  30kb
$s2 initial-rate-high  50kb
$s2 streams-threshold 100kb 500kb 800kb
$s2 attach-node $n9

set s3 [new SimStream/RTP ]
$s3 set isReceiver true
$s3 set level_ 2
#$s0 report-interval $opt(report_interval)
$s3 session_bw-low    $opt(low)
$s3 session_bw-medium    $opt(medium)
$s3 session_bw-high    $opt(high)
$s3 initial-rate-low  10kb
$s3 initial-rate-medium  30kb
$s3 initial-rate-high  50kb
$s3 streams-threshold 100kb 500kb 800kb
$s3 attach-node $n11

set s4 [new SimStream/RTP ]
$s4 set isReceiver true
$s4 set level_ 2
#$s0 report-interval $opt(report_interval)
$s4 session_bw-low    $opt(low)
$s4 session_bw-medium    $opt(medium)
$s4 session_bw-high    $opt(high)
$s4 initial-rate-low  10kb
$s4 initial-rate-medium  30kb
$s4 initial-rate-high  50kb
$s4 streams-threshold 100kb 500kb 800kb
$s4 attach-node $n12

set s5 [new SimStream/RTP ]
$s5 set isReceiver true
$s5 set level_ 3
#$s0 report-interval $opt(report_interval)
$s5 session_bw-low    $opt(low)
$s5 session_bw-medium    $opt(medium)
$s5 session_bw-high    $opt(high)
$s5 initial-rate-low  10kb
$s5 initial-rate-medium  30kb
$s5 initial-rate-high  50kb
$s5 streams-threshold 100kb 500kb 800kb
$s5 attach-node $n14

set s6 [new SimStream/RTP ]
$s6 set isReceiver true
$s6 set level_ 3
#$s0 report-interval $opt(report_interval)
$s6 session_bw-low    $opt(low)
$s6 session_bw-medium    $opt(medium)
$s6 session_bw-high    $opt(high)
$s6 initial-rate-low  10kb
$s6 initial-rate-medium  30kb
$s6 initial-rate-high  50kb
$s6 streams-threshold 100kb 500kb 800kb
$s6 attach-node $n15

$ns at 0.1 "$s0 join-groups $group1 $group2 $group3"
$ns at 0.1 "$s0 start"



$ns at 0.2 "$s1 assign-groups $group1 $group2 $group3"
$ns at 0.2 "$s1 join-group $group1"
$ns at 0.2 "$s1 start-session $group1"


$ns at 0.3 "$s2 assign-groups $group1 $group2 $group3"
$ns at 0.3 "$s2 join-group $group1"
$ns at 0.3 "$s2 start-session $group1"


$ns at 0.4 "$s3 assign-groups $group1 $group2 $group3"
$ns at 0.4 "$s3 join-group $group2"
$ns at 0.4 "$s3 start-session $group2"


$ns at 0.5 "$s4 assign-groups $group1 $group2 $group3"
$ns at 0.5 "$s4 join-group $group2"
$ns at 0.5 "$s4 start-session $group2"


$ns at 0.6 "$s5 assign-groups $group1 $group2 $group3"
$ns at 0.6 "$s5 join-group $group3"
$ns at 0.6 "$s5 start-session $group3"


$ns at 0.7 "$s6 assign-groups $group1 $group2 $group3"
$ns at 0.7 "$s6 join-group $group3"
$ns at 0.7 "$s6 start-session $group3"


$ns at 1.0 "$s0 transmit-low		$opt(low)"
$ns at 1.0 "$s0 transmit-medium		$opt(medium)"
$ns at 1.0 "$s0 transmit-high		$opt(high)"




#===================================
#        Record functions
#===================================
$ns at 1.0 "record-sink3"
$ns at 1.0 "record-sink4"
$ns at 1.0 "record-sink5"
$ns at 1.0 "record-s1"
$ns at 1.0 "record-s2"
$ns at 1.0 "record-s3"
$ns at 1.0 "record-s4"
$ns at 1.0 "record-s5"
$ns at 1.0 "record-s6"

# record the TCP throughput
proc record-sink3 {} {
        global sink3 f3
	#Get an instance of the simulator
	set ns [Simulator instance]
	#Set the time after which the procedure should be called again
        set time 0.5
	#How many bytes have been received by the traffic?
	set bw0 [$sink3 set bytes_]
        #Get the current time
        set now [$ns now]
	puts "$now"
#	puts "$now"
	#Calculate the bandwidth (in MBit/s) and write it to the files
	puts $f3 "$now [expr $bw0/$time*8]"
        #Reset the bytes_ values on the traffic sinks
        $sink3 set bytes_ 0
       	#Re-schedule the procedure
        $ns at [expr $now+$time] "record-sink3"
}
# record the TCP throughput
proc record-sink4 {} {
        global sink4 f4
	#Get an instance of the simulator
	set ns [Simulator instance]
	#Set the time after which the procedure should be called again
        set time 0.5
	#How many bytes have been received by the traffic?
	set bw0 [$sink4 set bytes_]
        #Get the current time
        set now [$ns now]
	#Calculate the bandwidth (in MBit/s) and write it to the files
	puts $f4 "$now [expr $bw0/$time*8]"
        #Reset the bytes_ values on the traffic sinks
        $sink4 set bytes_ 0
       	#Re-schedule the procedure
        $ns at [expr $now+$time] "record-sink4"
}

# record the TCP throughput
proc record-sink5 {} {
        global sink5 f5
	#Get an instance of the simulator
	set ns [Simulator instance]
	#Set the time after which the procedure should be called again
        set time 0.5
	#How many bytes have been received by the traffic?
	set bw0 [$sink5 set bytes_]
        #Get the current time
        set now [$ns now]
	#Calculate the bandwidth (in MBit/s) and write it to the files
	puts $f5 "$now [expr $bw0/$time*8]"
        #Reset the bytes_ values on the traffic sinks
        $sink5 set bytes_ 0
       	#Re-schedule the procedure
        $ns at [expr $now+$time] "record-sink5"
}



# record s1 thrughput
proc record-s1 {} {
	global s1 r1
        set ns [Simulator instance]
        set time  0.5
	set bw  [$s1 set rcv_rate_]
	set now [$ns now]
	puts $r1 "$now $bw"
        $ns at [expr $now+$time] "record-s1"
}

# record s2 thrughput
proc record-s2 {} {
        global s2 r2
        set ns [Simulator instance]
        set time  0.5
	set bw  [$s2 set rcv_rate_]
	set now [$ns now]
        puts $r2 "$now $bw"
        $ns at [expr $now+$time] "record-s2"
}

# record s2 thrughput
proc record-s3 {} {
        global s3 r3
        set ns [Simulator instance]
        set time  0.5
	set bw  [$s3 set rcv_rate_]
	set now [$ns now]
        puts $r3 "$now $bw"
        $ns at [expr $now+$time] "record-s3"
}

# record s2 thrughput
proc record-s4 {} {
        global s4 r4
        set ns [Simulator instance]
        set time 0.5
	set bw  [$s4 set rcv_rate_]
	set now [$ns now]
        puts $r4 "$now $bw"
        $ns at [expr $now+$time] "record-s4"
}

# record s2 thrughput
proc record-s5 {} {
        global s5 r5
        set ns [Simulator instance]
        set time  0.5
	set bw  [$s5 set rcv_rate_]
	set now [$ns now]
        puts $r5 "$now $bw"
        $ns at [expr $now+$time] "record-s5"
}

# record s2 thrughput
proc record-s6 {} {
        global s6 r6
        set ns [Simulator instance]
        set time  0.5
	set bw  [$s6 set rcv_rate_]
	set now [$ns now]
        puts $r6 "$now $bw"
        $ns at [expr $now+$time] "record-s6"
}


#===================================
#        Termination        
#===================================
#Define a 'finish' procedure
proc finish {} {
     global ns f3 f4 f5 r1 r2 r3 r4 r5 r6 tracefile namfile
     close $f3
     close $f4
     close $f5
     close $r1
     close $r2
     close $r3
     close $r4
     close $r5
     close $r6


     exec xgraph   sink3.tr sink4.tr  sink5.tr s1.tr s2.tr s3.tr  s4.tr s5.tr s6.tr -geometry 800x400  &

    $ns flush-trace
    close $tracefile
    close $namfile
    exec nam out.nam &
    exit 0
}



$ns at $opt(stop) "finish"
$ns run
